## org.apache.commons.collections.map
Class PredicatedMap

    java.lang.Object
      org.apache.commons.collections.map.AbstractMapDecorator
          org.apache.commons.collections.map.PredicatedMap

All Implemented Interfaces:
  java.io.Serializable, java.util.Map

Direct Known Subclasses:
  PredicatedSortedMap

    public class PredicatedMap

extends AbstractMapDecorator
implements java.io.Serializable

Decorates another `Map` to validate that additions match a specified predicate.

This map exists to provide validation for the decorated map. It is normally created to decorate an empty map. If an object cannot be added to the map, an IllegalArgumentException is thrown.

One usage would be to ensure that no null keys are added to the map.

    Map map = PredicatedSet.decorate(new HashMap(), NotNullPredicate.INSTANCE, null);

Note that PredicatedMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedMap(Map)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne, Paul Jack
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Field Summary
`protected Predicate` `keyPredicate` The key predicate to use
`protected Predicate` `valuePredicate` The value predicate to use

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` `PredicatedMap(java.util.Map map, Predicate keyPredicate, Predicate valuePredicate)` Constructor that wraps (not copies).

Method Summary
`protected java.lang.Object` `checkSetValue(java.lang.Object value)` Override to validate an object set into the map via `setValue`.
`static java.util.Map` `decorate(java.util.Map map, Predicate keyPredicate, Predicate valuePredicate)` Factory method to create a predicated (validating) map.
`java.util.Set` `entrySet()`
`protected boolean` `isSetValueChecking()` Override to only return true when there is a value transformer.
`java.lang.Object` `put(java.lang.Object key, java.lang.Object value)`
`void` `putAll(java.util.Map mapToCopy)`
`protected void` `validate(java.lang.Object key, java.lang.Object value)` Validates a key value pair.

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, equals, get, getMap, hashCode, isEmpty, keySet, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### keyPredicate

    protected final Predicate keyPredicate

  The key predicate to use

### valuePredicate

    protected final Predicate valuePredicate

  The value predicate to use

Constructor Detail

### PredicatedMap

    protected PredicatedMap(java.util.Map map,
                            Predicate keyPredicate,
                            Predicate valuePredicate)

  Constructor that wraps (not copies).

  Parameters:
    `map` - the map to decorate, must not be null
    `keyPredicate` - the predicate to validate the keys, null means no check
    `valuePredicate` - the predicate to validate to values, null means no check
  Throws:
    `java.lang.IllegalArgumentException` - if the map is null

Method Detail

### decorate

    public static java.util.Map decorate(java.util.Map map,
                                         Predicate keyPredicate,
                                         Predicate valuePredicate)

  Factory method to create a predicated (validating) map.

  If there are any elements already in the list being decorated, they are validated.

  Parameters:
    `map` - the map to decorate, must not be null
    `keyPredicate` - the predicate to validate the keys, null means no check
    `valuePredicate` - the predicate to validate to values, null means no check
  Throws:
    `java.lang.IllegalArgumentException` - if the map is null

### validate

    protected void validate(java.lang.Object key,
                            java.lang.Object value)

  Validates a key value pair.

  Parameters:
    `key` - the key to validate
    `value` - the value to validate
  Throws:
    `java.lang.IllegalArgumentException` - if invalid

### checkSetValue

    protected java.lang.Object checkSetValue(java.lang.Object value)

  Override to validate an object set into the map via `setValue`.

  Parameters:
    `value` - the value to validate
  Throws:
    `java.lang.IllegalArgumentException` - if invalid
  Since:
    Commons Collections 3.1

### isSetValueChecking

    protected boolean isSetValueChecking()

  Override to only return true when there is a value transformer.

  Returns:
    true if a value predicate is in use
  Since:
    Commons Collections 3.1

### put

    public java.lang.Object put(java.lang.Object key,
                                java.lang.Object value)

  Specified by:
    `put` in interface `java.util.Map`
  Overrides:
    `put` in class `AbstractMapDecorator`

### putAll

    public void putAll(java.util.Map mapToCopy)

  Specified by:
    `putAll` in interface `java.util.Map`
  Overrides:
    `putAll` in class `AbstractMapDecorator`

### entrySet

    public java.util.Set entrySet()

  Specified by:
    `entrySet` in interface `java.util.Map`
  Overrides:
    `entrySet` in class `AbstractMapDecorator`

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.